import { FSNode, FSTree } from './FSTree';

declare class PageRoute {
    readonly fsNode: FSNode;
    parent?: LayoutRoute;
    constructor(fsNode: FSNode);
    get id(): number;
    get path(): string;
    render(indent?: number, tabSize?: number): string[];
}
declare class LayoutRoute {
    readonly fsNode: FSNode;
    parent?: LayoutRoute;
    children: (LayoutRoute | PageRoute)[];
    constructor(fsNode: FSNode);
    get id(): number;
    render(indent?: number, tabSize?: number): string[];
}
export declare class FSRouter {
    readonly fsTree: FSTree;
    constructor(fsTree: FSTree);
    pageRoutes: Map<number, PageRoute>;
    addPageNode(fsNode: FSNode): void;
    layoutRoutes: Map<number, LayoutRoute>;
    addLayoutNode(fsNode: FSNode): void;
    build(): void;
    render(tabSize?: number): string;
    update(): void;
    static makeLayoutComponentName(id: number): string;
    static makePageComponentName(id: number): string;
}
export {};
