import { Logger, ViteDevServer } from 'vite';
import { PluginOptions } from '../plugin';
import { FSTree } from './FSTree';

export type ReactPagesChange = (this: ReactPages) => unknown;
export declare class ReactPages {
    readonly cwd: string;
    readonly options: PluginOptions;
    logger: Logger;
    fsTree: FSTree;
    absPagesDir: string;
    constructor(cwd: string, options: PluginOptions);
    generate(): Promise<string>;
    private _inPagesDir;
    private devServer?;
    private onChange?;
    watch(devServer: ViteDevServer, onChange: ReactPagesChange): Promise<void>;
    private _isSetup;
    get isSetup(): boolean;
    setup(): Promise<void>;
    teardown(): void;
    addFile(file: string): Promise<void>;
    updateFile(file: string): void;
    removeFile(file: string): Promise<void>;
}
