import { LogLevel, Plugin } from 'vite';
import { DeepPartial } from './helpers';
import { FileType } from './core/FSTree';

export interface PluginOptions {
    /**
     * 是否开启调试模式
     */
    debug: boolean;
    /**
     * 应用页面目录
     * @default 'src/pages'
     */
    pagesDir: string;
    /**
     * 文件名映射
     */
    fileNames: Record<FileType, string | string[]>;
    /**
     * 日志等级
     */
    logLevel: LogLevel;
    /**
     * 是否禁用懒加载
     */
    disableLazy: boolean;
    /**
     * 是否区分大小写
     */
    caseSensitive: boolean;
    /**
     * 排除文件，默认排除 node_modules
     */
    excludes: string[];
}
export type UserPluginOptions = DeepPartial<PluginOptions>;
export declare function reactPages(userPluginOptions?: UserPluginOptions): Plugin;
